;;; ======================================================================
;;; wx_panel.clp
;;; ======================================================================

(defclass MAIN::wxPanel (is-a wxCanvas)
	(slot resource
		(create-accessor read-write)
		(access initialize-only)
		(visibility public)
		(type STRING)
		(default ""))

	(role concrete)
)

;;; ======================================================================
;;; DEFMESSAGE-HANDLERS
;;; ======================================================================

(defmessage-handler MAIN::wxPanel create ()
  
        (send ?self win-init)

	;; Create the panel.
        
        (bind ?parent-id 0)
        (if (neq ?self:parent nil) then (bind ?parent-id (send ?self:parent get-id)))

        (if (neq ?self:resource "") then
          (bind ?self:id (panel-create-from-resource ?parent-id ?self:resource))
         else
  	  (bind ?self:id
		(panel-create	?parent-id
				?self:x
				?self:y
				?self:width
				?self:height
				?self:style
				?self:window-name
        )))
        (if (> ?self:id 0) then
          (bind ?self:dc (make-instance (gensym) of wxCanvasDC (id (canvas-get-dc ?self:id))))
          (instance-table-add-entry ?self:id (instance-name ?self))
          (send ?self add-event-handlers))
)

(defmessage-handler MAIN::wxPanel set-button-font (?font)
  (return (long-to-bool (panel-set-button-font ?self:id ?font)))
)

(defmessage-handler MAIN::wxPanel set-label-font (?font)
  (return (long-to-bool (panel-set-label-font ?self:id ?font)))
)

(defmessage-handler MAIN::wxPanel set-label-position (?pos)
  (return (long-to-bool (panel-set-label-position ?self:id ?pos)))
)

(defmessage-handler MAIN::wxPanel new-line ()
  (return (long-to-bool (panel-new-line ?self:id)))
)
